Distribution:		CCux
Packager:		Christian Metzen <metzench@ccux-linux.de>

Summary: 		The GNOME Display Manager.
Name: 			gdm
Version: 		2.20.3
Release: 		3
Epoch:			1
License: 		LGPL/GPL
Group: 			User Interface/X
URL: 			ftp://ftp.gnome.org/pub/GNOME/sources/gdm
Source: 		gdm-%{PACKAGE_VERSION}.tar.bz2
Source1: 		gdm-pam
Source2: 		gdm-autologin-pam
Source3: 		gdmsetup-pam
Source4:		gdm.init
Source5:		ccux-linux-0.1.tar.bz2
Patch1: 		gdm-change-ccux-defaults.patch
BuildRoot: 		%{_tmppath}/gdm-%{PACKAGE_VERSION}-root
Prereq: 		/usr/sbin/useradd
Prereq: 		/usr/bin/scrollkeeper-update
Requires: 		gtk2+
Requires: 		libglade
Requires: 		libgnomeui
Requires: 		libgnomecanvas
Requires: 		librsvg
Requires: 		libxml2
Requires: 		pam
Requires: 		/etc/pam.d/system-auth
Requires: 		usermode
Requires: 		/sbin/nologin
Requires: 		xorg-x11-server-utils
Requires: 		xorg-x11-xkb-utils
Requires: 		xorg-x11-xinit
Requires:		gdm-theme-CCuxLinux-Black
BuildRequires: 		scrollkeeper
BuildRequires: 		pango-devel
BuildRequires: 		gtk2+-devel
BuildRequires: 		libglade-devel
BuildRequires: 		libgnomeui-devel
BuildRequires: 		libgnomecanvas-devel
BuildRequires: 		librsvg-devel
BuildRequires: 		libxml2-devel
BuildRequires: 		usermode
BuildRequires: 		pam-devel
BuildRequires: 		fontconfig
BuildRequires: 		desktop-file-utils
BuildRequires: 		gail-devel
BuildRequires: 		libgsf-devel
BuildRequires: 		libtool automake autoconf
BuildRequires: 		libcroco-devel
BuildRequires: 		libattr-devel
BuildRequires: 		gettext 
BuildRequires: 		gnome-doc-utils
BuildRequires: 		libdmx-devel
BuildRequires: 		intltool
BuildRequires: 		xorg-x11-server-Xorg
BuildRequires: 		nss-devel

%description
Gdm (the GNOME Display Manager) is a highly configurable
reimplementation of xdm, the X Display Manager. Gdm allows you to log
into your system with the X Window System running and supports running
several different X sessions on your local machine at the same time.

%prep
%setup -q

%patch1 -p1 -b .change-defaults

%build
cp -f %{SOURCE1} config/gdm
cp -f %{SOURCE2} config/gdm-autologin
cp -f %{SOURCE3} gdmsetup-pam

intltoolize --force --copy
aclocal
libtoolize --force --copy
automake --add-missing
autoconf
autoheader
%configure --with-pam-prefix=%_sysconfdir --enable-console-helper --disable-scrollkeeper  --without-selinux --sysconfdir=%_sysconfdir/gnome \
    --localstatedir=/var/lib --libexecdir=$(pkg-config --variable=prefix ORBit-2.0)/lib/gdm
make

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/gnome/gdm/Init
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/gnome/gdm/PreSession
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/gnome/gdm/PostSession

make install DESTDIR=$RPM_BUILD_ROOT

# docs go elsewhere
rm -rf $RPM_BUILD_ROOT/%{_prefix}/doc

# create log dir
mkdir -p $RPM_BUILD_ROOT/var/log/gdm

# remove the gdm Xsession as we're using the xdm one
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/gnome/gdm/Xsession
(cd $RPM_BUILD_ROOT%{_sysconfdir}/gnome/gdm; ln -sf ../../X11/xinit/Xsession .)

rm -f $RPM_BUILD_ROOT%{_libdir}/gtk-2.0/modules/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/gtk-2.0/modules/*.la

# remove the gnome session file, since we don't use it anymore
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/X11/dm/Sessions/gnome.desktop

# remove the other gnome session file, since we put it in gnome-session
rm -rf $RPM_BUILD_ROOT%{_datadir}/xsessions

# no dumb flexiserver thing, Xnest is too broken
rm -f $RPM_BUILD_ROOT%{_datadir}/applications/gdmflexiserver-xnest.desktop

# use consolehelper for gdmsetup
(cd $RPM_BUILD_ROOT/usr/bin; ln -sf consolehelper gdmsetup)

# fix the "login photo" file
# FIXME: work around invalid categories for now
#desktop-file-install --vendor gnome --delete-original       \
#  --dir $RPM_BUILD_ROOT%{_datadir}/applications             \
#  $RPM_BUILD_ROOT%{_datadir}/applications/gdmphotosetup.desktop || :

rm -f $RPM_BUILD_ROOT%{_datadir}/applications/gdmflexiserver.desktop

# broken install-data-local in gui/Makefile.am makes this necessary
(cd $RPM_BUILD_ROOT%{_bindir} && ln -sf gdmXnestchooser gdmXnest)

rm -rf $RPM_BUILD_ROOT%{_localstatedir}/lib/scrollkeeper

install -m 755 -d $RPM_BUILD_ROOT%_sysconfdir/rc.d/init.d
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%_sysconfdir/rc.d/init.d/gdm

#tar xvfj %{SOURCE5} -C $RPM_BUILD_ROOT%{_datadir}/gdm/themes

%find_lang gdm --with-gnome

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/useradd -u 42 -d /var/lib/gdm -s /sbin/nologin gdm > /dev/null 2>&1
/usr/sbin/usermod -d /var/lib/gdm -s /sbin/nologin gdm >/dev/null 2>&1
# ignore errors, as we can't disambiguate between gdm already existed
# and couldn't create account with the current adduser.
exit 0

%post
/sbin/ldconfig
scrollkeeper-update
touch --no-create /usr/share/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  gtk-update-icon-cache -q /usr/share/icons/hicolor
fi
sed -i -e 's#id:3:initdefault:#id:5:initdefault:#' /etc/inittab
echo -e "Changed default Runlevel to 5 in /etc/inittab for Graphical Login!"
/sbin/chkconfig --add gdm
/sbin/chkconfig gdm resetpriorities


%postun
/sbin/ldconfig
scrollkeeper-update
touch --no-create %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  gtk-update-icon-cache -q %{_datadir}/icons/hicolor
fi
if [ $1 -eq 0 ]; then
    sed -i -e 's#id:5:initdefault:#id:3:initdefault:#' /etc/inittab
    echo -e "Changed default Runlevel to 3 in /etc/inittab!"
fi

%files -f gdm.lang
%defattr(-, root, root)
%doc AUTHORS COPYING ChangeLog NEWS README TODO
%_sysconfdir/rc.d/init.d/gdm
%dir %{_sysconfdir}/gnome/gdm
%{_sysconfdir}/gnome/gdm/Xsession
%config(noreplace) %{_sysconfdir}/gnome/gdm/custom.conf
#%config %{_sysconfdir}/gnome/gdm/securitytokens.conf
%config %{_sysconfdir}/gnome/gdm/XKeepsCrashing
%config %{_sysconfdir}/gnome/gdm/locale.alias
%config %{_sysconfdir}/gnome/gdm/Init/*
%config %{_sysconfdir}/gnome/gdm/PostLogin/*
%config %{_sysconfdir}/gnome/gdm/PreSession/*
%config %{_sysconfdir}/gnome/gdm/PostSession/*
%config %{_sysconfdir}/gnome/gdm/modules/*
%config %{_sysconfdir}/pam.d/gdm
%config %{_sysconfdir}/pam.d/gdmsetup
%config %{_sysconfdir}/pam.d/gdm-autologin
%config %{_sysconfdir}/security/console.apps/gdmsetup
%dir %{_sysconfdir}/gnome/gdm/Init
%dir %{_sysconfdir}/gnome/gdm/PreSession
%dir %{_sysconfdir}/gnome/gdm/PostSession
%dir %{_sysconfdir}/gnome/gdm/PostLogin
%dir %{_sysconfdir}/gnome/gdm/modules
%{_datadir}/pixmaps
%{_datadir}/icons
%{_datadir}/gdm
#%{_datadir}/applications
%{_datadir}/gnome/help/gdm
%{_datadir}/omf/gdm
%{_libdir}/gtk-2.0/modules/*.so
%{_bindir}/*
%{_libdir}/gdm/*
%{_mandir}/man*/*
%{_sbindir}/*
%dir %{_localstatedir}/log/gdm
%attr(1770, root, gdm) %dir %{_localstatedir}/lib/gdm

%changelog
* Sun Aug 02 2008 Christian Metzen <metzench@ccux-linux.de> 1:2.20.3-3
- theme bugfix
* Sun Aug 02 2008 Christian Metzen <metzench@ccux-linux.de> 1:2.20.3-2
- added new ccux default theme
* Wed Mar 05 2008 Christian Wasem <wasem@ccux-linux.de> 1:2.20.3-1
- Version Update
* Fri Oct 05 2007 Christian Metzen <metzench@ccux-linux.de> 1:2.20.0-2
- some tweaks
* Fri Sep 28 2007 Christian Metzen <metzench@ccux-linux.de> 1:2.20.0-1
- Version update
* Tue Mar 19 2007 Christian Metzen <metzench@ccux-linux.de> 1:2.18.0-1
- Version update
* Sun Jan 21 2007 Christian Metzen <metzench@ccux-linux.de> 1:2.17.5-3
- fixed wrong Xorg location
* Sun Jan 21 2007 Christian Metzen <metzench@ccux-linux.de> 1:2.17.5-2
- corrected version
* Sat Jan 20 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.17.5-1
- Version update
* Thu Nov 17 2006 Christian Metzen <metzench@ccux-linux.de> 2.17.2-7
- added CCux gdm theme and adjusted Defaults
* Thu Nov 17 2006 Christian Metzen <metzench@ccux-linux.de> 2.17.2-6
- fixed initscript to work with chkconfig
* Thu Nov 17 2006 Christian Metzen <metzench@ccux-linux.de> 2.17.2-5
- added startup script
* Wed Nov 16 2006 Christian Metzen <metzench@ccux-linux.de> 2.17.2-4
- fixed Xsessions link
* Wed Nov 16 2006 Christian Metzen <metzench@ccux-linux.de> 2.17.2-3
- some install tweaks
* Mon Nov 13 2006 Christian Metzen <metzench@ccux-linux.de> 2.17.2-2
- patched default config
* Mon Nov 13 2006 Christian Metzen <metzench@ccux-linux.de> 2.17.2-1
- Initial release
